#
# This file was generated using xslt from its XML file
#
# Copyright 2009, Associated Universities Inc., Washington DC
#
import sys
import os
from  casac import *
import string
from taskinit import casalog
from taskinit import xmlpath
#from taskmanager import tm
import task_conjugatevis
def conjugatevis(vis='', spwlist="", outputvis='', overwrite=False):

        """Change the sign of the phases in all visibility columns.
	Change the sign of the phases in all visibility columns

	Keyword arguments:
	vis -- Name of input visibility file
		default: none; example='3C273XC1.ms'
	spwlist -- Select spectral window
		default: [] all spws will be conjugated; example: spw=[1,2]
	outputvis -- name of output visibility file
	        default: 'conjugated_'+vis; example= 'conjugated.ms'
	overwrite -- Overwrite the outputvis if it exists
		default=False; example: overwrite=True

	Example:

           conjugatevis(vis='NGC253.ms', spwlist=[0,1], outputvis='NGC253-conj.ms')

        Will conjugate all visibilities for spectral windows 0 and 1 and store the
	modified data in NGC253-conj.ms.


        """

#
#    The following is work around to avoid a bug with current python translation
#
        mytmp = {}

        mytmp['vis'] = vis
        mytmp['spwlist'] = spwlist
        mytmp['outputvis'] = outputvis
        mytmp['overwrite'] = overwrite
	pathname='file:///'+os.environ.get('CASAPATH').split()[0]+'/xml/'
	trec = casac.utils().torecord(pathname+'conjugatevis.xml')

        casalog.origin('conjugatevis')
        if trec.has_key('conjugatevis') and casac.utils().verify(mytmp, trec['conjugatevis']) :
	    result = task_conjugatevis.conjugatevis(vis, spwlist, outputvis, overwrite)

	else :
	  result = False
        return result
