#
# This file was generated using xslt from its XML file
#
# Copyright 2008, Associated Universities Inc., Washington DC
#
import sys
import os
from casac import *
import string
import time
from casa_stack_manip import stack_frame_find
import gc
import numpy
from odict import odict
from task_imfit import imfit
from taskinit import casalog
from taskinit import xmlpath
class imfit_pg_:
    __name__ = "imfit"

    def __init__(self) :
       self.__bases__ = (imfit_pg_,)
       self.__doc__ = self.__call__.__doc__


    def __call__(self, imagename=None,box=None,region=None,chans=None,stokes=None,mask=None,includepix=None,excludepix=None,residual=None,model=None,estimates=None,logfile=None,append=None,newestimates=None,complist=None,overwrite=None,dooff=None,offset=None,fixoffset=None,stretch=None,rms=None,noisefwhm=None,summary=None,):

        myf=stack_frame_find( )
        myf['__last_task'] = 'imfit'
        myf['taskname'] = 'imfit'
        ###
        myf['update_params'](func=myf['taskname'],printtext=False)
        ###
        ###
        #Handle globals or user over-ride of arguments
        #
	function_signature_defaults=dict(zip(self.__call__.func_code.co_varnames,self.__call__.func_defaults))
	useLocalDefaults = False

        for item in function_signature_defaults.iteritems():
                key,val = item
                keyVal = eval(key)
                if (keyVal == None):
                        #user hasn't set it - use global/default
                        pass
                else:
                        #user has set it - use over-ride
			if (key != 'self') :
			   useLocalDefaults = True
                        #myf[key]=keyVal

	myparams = {}
	if useLocalDefaults :
	   for item in function_signature_defaults.iteritems():
	       key,val = item
	       keyVal = eval(key)
	       exec('myparams[key] = keyVal')
	       if (keyVal == None):
	           exec('myparams[key] = '+ key + ' = self.itsdefault(key)')
		   keyVal = eval(key)
		   if(type(keyVal) == dict) :
                      if len(keyVal) > 0 :
		         exec('myparams[key] = ' + key + ' = keyVal[len(keyVal)-1][\'value\']')
		      else :
		         exec('myparams[key] = ' + key + ' = {}')

	else :
            uselessvariable = None 
            myparams['imagename'] = imagename = myf['imagename']
            myparams['box'] = box = myf['box']
            myparams['region'] = region = myf['region']
            myparams['chans'] = chans = myf['chans']
            myparams['stokes'] = stokes = myf['stokes']
            myparams['mask'] = mask = myf['mask']
            myparams['includepix'] = includepix = myf['includepix']
            myparams['excludepix'] = excludepix = myf['excludepix']
            myparams['residual'] = residual = myf['residual']
            myparams['model'] = model = myf['model']
            myparams['estimates'] = estimates = myf['estimates']
            myparams['logfile'] = logfile = myf['logfile']
            myparams['append'] = append = myf['append']
            myparams['newestimates'] = newestimates = myf['newestimates']
            myparams['complist'] = complist = myf['complist']
            myparams['overwrite'] = overwrite = myf['overwrite']
            myparams['dooff'] = dooff = myf['dooff']
            myparams['offset'] = offset = myf['offset']
            myparams['fixoffset'] = fixoffset = myf['fixoffset']
            myparams['stretch'] = stretch = myf['stretch']
            myparams['rms'] = rms = myf['rms']
            myparams['noisefwhm'] = noisefwhm = myf['noisefwhm']
            myparams['summary'] = summary = myf['summary']

        if type(includepix)==int: includepix=[includepix]
        if type(excludepix)==int: excludepix=[excludepix]

	result = None

#
#    The following is work around to avoid a bug with current python translation
#
        mytmp = {}

        mytmp['imagename'] = imagename
        mytmp['box'] = box
        mytmp['region'] = region
        mytmp['chans'] = chans
        mytmp['stokes'] = stokes
        mytmp['mask'] = mask
        mytmp['includepix'] = includepix
        mytmp['excludepix'] = excludepix
        mytmp['residual'] = residual
        mytmp['model'] = model
        mytmp['estimates'] = estimates
        mytmp['logfile'] = logfile
        mytmp['append'] = append
        mytmp['newestimates'] = newestimates
        mytmp['complist'] = complist
        mytmp['overwrite'] = overwrite
        mytmp['dooff'] = dooff
        mytmp['offset'] = offset
        mytmp['fixoffset'] = fixoffset
        mytmp['stretch'] = stretch
        mytmp['rms'] = rms
        mytmp['noisefwhm'] = noisefwhm
        mytmp['summary'] = summary
	pathname='file:///'+os.environ.get('CASAPATH').split()[0]+'/xml/'
	trec = casac.utils().torecord(pathname+'imfit.xml')

        casalog.origin('imfit')
        if not trec.has_key('imfit') or not casac.utils().verify(mytmp, trec['imfit']) :
	    return False


	try :
          casalog.post('')
          casalog.post('##########################################')
          casalog.post('##### Begin Task: imfit           #####')
          casalog.post('')
          result = imfit(imagename, box, region, chans, stokes, mask, includepix, excludepix, residual, model, estimates, logfile, append, newestimates, complist, overwrite, dooff, offset, fixoffset, stretch, rms, noisefwhm, summary)
          casalog.post('')
          casalog.post('##### End Task: imfit           #####')
          casalog.post('##########################################')


# saveinputs for individule engine has no use
# saveinputs should alos be removed from casa_in_py.py
#
#
#          saveinputs = myf['saveinputs']
#          saveinputs('imfit', 'imfit.last', myparams)
#
#
	except Exception, instance:
	  if(myf.has_key('__rethrow_casa_exceptions') and myf['__rethrow_casa_exceptions']) :
	     raise
	  else:
	     tname = 'imfit'
	     casalog.post('An error occurred running task %s: %s' % (tname,instance), 'ERROR')
	     pass

        gc.collect()
        return result
#
#
##
#    def paramgui(self, useGlobals=True):
#        """
#        Opens a parameter GUI for this task.  If useGlobals is true, then any relevant global parameter settings are used.
#        """
#        import paramgui
#
#        myf = stack_frame_find( )
#
#        if useGlobals:
#            paramgui.setGlobals(myf)
#        else:
#            paramgui.setGlobals({})
#
#        paramgui.runTask('imfit', myf['_ip'])
#        paramgui.setGlobals({})
#
#
#
#
    def defaults(self, param=None):
        myf=stack_frame_find( )
        a = odict()
        a['imagename']  = ''
        a['box']  = ''
        a['region']  = ''
        a['chans']  = ''
        a['stokes']  = ''
        a['mask']  = ''
        a['includepix']  = []
        a['excludepix']  = []
        a['residual']  = ''
        a['model']  = ''
        a['estimates']  = ''
        a['logfile']  = ''
        a['newestimates']  = ''
        a['complist']  = ''
        a['dooff']  = False
        a['rms']  = -1
        a['noisefwhm']  = ''
        a['summary']  = ''

        a['mask'] = {
                    0:odict([{'notvalue':''}, {'stretch':False}])}
        a['logfile'] = {
                    0:odict([{'notvalue':''}, {'append':True}])}
        a['complist'] = {
                    0:odict([{'notvalue':''}, {'overwrite':False}])}
        a['dooff'] = {
                    0:odict([{'notvalue':False}, {'offset':0.0}, {'fixoffset':False}])}

### This function sets the default values but also will return the list of
### parameters or the default value of a given parameter
        if(param == None):
                myf['__set_default_parameters'](a)
        elif(param == 'paramkeys'):
                return a.keys()
        else:
	        if(a.has_key(param)):
		   #if(type(a[param]) == dict) :
		   #   return a[param][len(a[param])-1]['value']
	   	   #else :
		      return a[param]


#
#
    def check_params(self, param=None, value=None):
      myf=stack_frame_find( )

#      print 'param:', param, 'value:', value
      try :
         if str(type(value)) != "<type 'instance'>" :
            value0 = value
            value = myf['cu'].expandparam(param, value)
            matchtype = False
            if(type(value) == numpy.ndarray):
               if(type(value) == type(value0)):
                  myf[param] = value.tolist()
               else:
                  #print 'value:', value, 'value0:', value0
                  #print 'type(value):', type(value), 'type(value0):', type(value0)
                  myf[param] = value0
                  if type(value0) != list :
                     matchtype = True
            else :
               myf[param] = value
            value = myf['cu'].verifyparam({param:value})
            if matchtype:
               value = False
      except Exception, instance:
         #ignore the exception and just return it unchecked
         myf[param] = value
      return value

#
#
    def itsdefault(self, paramname) :
        a = {}
        a['imagename']  = ''
        a['box']  = ''
        a['region']  = ''
        a['chans']  = ''
        a['stokes']  = ''
        a['mask']  = ''
        a['includepix']  = []
        a['excludepix']  = []
        a['residual']  = ''
        a['model']  = ''
        a['estimates']  = ''
        a['logfile']  = ''
        a['append']  = True
        a['newestimates']  = ''
        a['complist']  = ''
        a['overwrite']  = False
        a['dooff']  = False
        a['offset']  = 0.0
        a['fixoffset']  = False
        a['stretch']  = False
        a['rms']  = -1
        a['noisefwhm']  = ''
        a['summary']  = ''

        if a.has_key(paramname) :
	      return a[paramname]
imfit_pg = imfit_pg_()
